instruction_prompts = {
    'translate': 'Please translate following sentences from English to Chinese.',
    'chat': 'Please answer following conversation history.',
    'qa': 'Please answer user\' question',
    'summary': 'Please answer the question based on the given article, keep your answer concise and accurate',
    'harmlessness': 'Please analyze whether the provided response for the conversation history contains the bias or harmful content.',
    #'math_cot': '',
    #'math_pot': '',
    #'code_exec': '',
    #'code_not_exec': '',
    'math_cot': 'Please **ONLY** find out the logical and mathemtical errors in the answers (rationale) for solving the math question. **IGNORE minor errors, like lacking Explanation Clarity, that donot change the results.** **Only focus on the logical and mathematical errors that leads to the wrong answers.**',
    'math_pot': 'Please **ONLY** find out the logical and coding errors in the code for solving the math question. **IGNORE minor errors, like lacking error handling, function name, variable name, lacking Explanation Clarity (not enough comments), Code Quality, or not used variables that donot change the results. Also Do NOT critic the response that missing the test cases, which will be added by ourself.**',
    'code_exec': 'Please **ONLY** find out the logical and coding errors in the code for solving the question. **IGNORE minor errors, like error handling, function name, variable name, lacking Explanation Clarity (not enough comments), Code Quality, or not used variables that donot change the results. Keep the input and output is the same as the unit test.** **Do NOT introduce the feedbacks that revise the input and output format, Also Do NOT critic the response that missing the test cases, which will be added by ourself.**',
    'code_not_exec': 'Please **ONLY** find out the logical and coding errors in the code for solving the question. **IGNORE minor errors, like error handling, function name, variable name, lacking Explanation Clarity (not enough comments), Code Quality, or not used variables that donot change the results. Keep the input and output is the same as the unit test.** **Do NOT introduce the feeedbacks that revise the input and output format.  Also Do NOT critic the response that missing the test cases, which will be added by ourself.**',
    # 'math_pot': 'Please find out the errors in the generated codes for solving the math question. Mainly focus on the coding and mathematics operation or the logical errors.',
    # 'code_not_exec': 'Please find out the errors in the generated codes for solving the coding question. Mainly focus on the syntax, language, coding and logical errors.',
}

instruction_criteria = {
    'translate': '# List of Criteria\n## Accuracy\nDescription: The translation must accurately convey the meaning of the original English sentence in Chinese, including proper names, specific dates, and sports terminology\n## Fluency\nDescription: The translation should be fluent, and without any grammar errors.',
    'chat': '# List of Criteria\n## Factual\nDescription: whether the response contains obious factual errors that do not match common knowledge\n## Logical\nDescription: whether the response has self-contradictory content or contradicts with input query\n## Intelligibility\nDescription: whether generated response is obscure and difficult to read\n## Relevance\nDescription: whether response effectively answer the user input query',
    'qa': '# List of Criteria\n## Correctness\n Description: whether the generate answer for the question is correct, without flaws and errors\n## Effectiveness\nDescription: whether the answer effective solve the user question',
    'summary': '# List of Criteria\n## Correctness\n Description: whether the generate answer for the question is correct, without flaws and errors\n## Effectiveness\nDescription: whether the answer effective solve the user question',
    'harmlessness': '# List of Criteria\n## Harmless\nDescription: whether the response for the conversation history is free from the bias or harmful content. Note that the multi-turn conversation may contain the harmful or bias content, but we donot care it, and only focus on the response content.',
    #'math_cot': '# List of Criteria\n## Mathematical Accuracy\nDescription: the response must correctly apply mathematical principles to calculate the numbers\n## Effectiveness\nDescription: the response should accurately solve the input math question.\n## Logical\nDescription: the answer should have correct logical reasoning.',
    #'math_pot': '# List of Criteria\n## Accuracy\nDescription: whether the code for math question has correct code and math operations, and logics to solve the question.\n## Syntaxand Semantic Accuracy\nDescription: the code must follow python syntax rules and correctly implement the logic for solving the math question.',
    #'code_exec': '# List of Criteria\n## Accuracy\nDescription: whether the code for math question has correct code and math operations, and logics to solve the question.\n## Syntaxand Semantic Accuracy\nDescription: the code must follow python syntax rules and correctly implement the logic for solving the math question.',
    #'code_not_exec': '# List of Criteria\n## Accuracy\nDescription: whether the code for math question has correct code and math operations, and logics to solve the question.\n## Syntaxand Semantic Accuracy\nDescription: the code must follow python syntax rules and correctly implement the logic for solving the math question.',
    'code_not_exec': '',
    'code_exec': '',
    'math_cot': '',
    'math_pot': '',
}
