question_source_dict = {
    'Date': '''# Two-tier Structure of Criteria\n## Accuracy of Calculation\nDescription: Evaluates whether the assistant's response accuratly calculates the date from the provided data.\n\n### Correct Date Calculation\nDescription: The assistant's response must correctly calculate the date from the given date. Please make sure the date are accurately counted. Note that the days in each month are different.\nDegree: important\n\n### Correct Format\nDescription: The assistant's response must present the date in the correct format (MM/DD/YYYY).\nDegree: important\n\n## Clarity of Explanation\nDescription: Assesses how clearly the assistant explains the calculation process or reasoning behind the answer.\n\n### Step-by-Step Explanation\nDescription: The assistant should provide a clear, step-by-step explanation of how the date was calculated, making it easy for the user to understand the process.\nDegree: medium.''',
    'Penguins': '''# Two-tier Structure of Criteria\n## Accuracy of Information\nDescription: The response must correctly identify and provide the answer provided in the table.\n\n### Correct Identification of Penguin\nDescription: The response should accurately identify data from the list of penguins.\nDegree: important\n\n## Clarity of Communication\nDescription: The response should be clear and easily understandable, avoiding any ambiguity or confusion.''',
    'Colored Object': '''# Two-tier Structure of Criteria\n## Accuracy of Information\nDescription: The response must correctly identify the color based on the information provided in the query.\n\n### Correct Identification of Color\nDescription: The response should accurately match the color of the object with the correct option from the given list.\nDegree: important\n\n### Logical Consistency\nDescription: The response should maintain logical consistency with the arrangement of the objects as described\nDegree: important''',
    # algorithm 55.32 -> 60.99
    'Object Counting': '''# Two-tier Structure of Criteria\n## Accuracy of Calculation\nDescription: The response must correctly calculate the number of items based on the information provided by the user.\n\n### Correct Counting\nDescription: Each item mentioned by the user is accurately counted, ensuring no item is omitted or counted twice.\nDegree: important\n\n### Correct Mathematical Operation\nDescription: The assistant uses the correct mathematical operation (addition) to find the total number of items.\nDegree: important\n\n## Clarity of Explanation\nDescription: The response should clearly explain the process of calculating the total number of items, making it easy for the user to understand how the answer was derived.\n\n### Step-by-Step Explanation\nDescription: The assistant provides a clear, step-by-step explanation of how the total number of musical instruments is calculated, including the count of each instrument.\nDegree: medium''',
    'Repeat Copy': '''# Two-tier Structure of Criteria\n## Accuracy of Execution\nDescription: Evaluates how precisely the assistant followed the user's instructions, including the correct application of the specified condition.\n\n### Correct Application of Condition\nDescription: Assesses whether the assistant correctly identified and applied the condition to drop words starting with vowels on odd repetitions.\nDegree: important\n\n### Correct Repetition Count\nDescription: Checks if the assistant repeated the phrase the required number of times as specified by the user.\nDegree: important\n\n### Without Explanation\nDescription: generate the results without any explanation.\nDegree: important## Clarity and Coherence\nDescription: Measures how clearly and coherently the assistant's response is structured, ensuring it is understandable and logically follows the user's instructions.\n\n### Readability\nDescription: Assesses the ease with which the user can read and understand the response, considering the nature of the task.\nDegree: medium.'''
}
